/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */

package bandit.util;

import java.time.LocalDateTime;
import java.util.logging.*;
/**
 *
 * @author le
 */
public class OhmLogger
{
  private static Logger lg = null;
  
  private OhmLogger() //Singelton-Patter -> privater ctor -> anlegen nur über klassenmethode möglich
  {
  }
  
  public static Logger getLogger()
  {
    if (lg == null)
    {
      lg = Logger.getLogger("OhmLogger");
      initLogger();
    }
    return lg;
  }
  
  private static void initLogger()
  {
//    FileHandler fh = new FileHandler();
    ConsoleHandler ch = new ConsoleHandler();
    ch.setFormatter(new OhmFormatter());
    lg.addHandler(ch);
  }
}

class OhmFormatter extends SimpleFormatter
{
  @Override
  public String format(LogRecord record)
  {
    String logline = "";
    
    LocalDateTime ldt = LocalDateTime.now();
    logline += ldt.toString();
    logline += ";" + record.getMessage();
    logline += "\n";
    
    return logline;
  }
}
